SystemOrganization addCategory: #'Sight-Dynamic'!

UiItemModel subclass: #SdCallgraphModel
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdCallgraphModel commentStamp: 'mt 3/23/2011 14:44:06.545' prior: 0!
| cgt tree |
cgt := SdCallgraphTracer new.
cgt profilingMode: #ms.
cgt selectedCategories: (PackageInfo named: #Widgets) systemCategories.
cgt callgraphModel: SdCallgraph new.
cgt traceSourceCode: 'UiTextEdit new'.
tree := UiTreeView new model: (SdCallgraphModel new root: cgt callgraphModel).
tree openInWorld.!

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 3/23/2011 14:40:22.991'!
columnCountFor: aParentModelIndex

	^ 2! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 3/23/2011 14:40:50.752'!
iconFor: aModelIndex

	(aModelIndex row = 0 or: [aModelIndex column = 0])
		ifTrue: [^ nil].
	
	aModelIndex column = 2
		ifTrue: [^ nil].
	
	^ (aModelIndex valueOfProperty: #snode) ifNotNil: [:snode |
		(snode clientClass inheritsFrom: Morph)
			ifTrue: [snode clientClass widgetClassIcon]
			ifFalse: [nil]]! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/28/2011 11:46:06.509'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	| index snode |
	index := (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex.
		
	"Header indices."
	(aRowNumber = 0 or: [aColumnNumber = 0])
		ifTrue: [^ index].
		
	snode := aParentModelIndex
		ifNil: [self root rootNode]
		ifNotNil: [aParentModelIndex valueOfProperty: #snode].
		
	index
		setProperty: #snode
		toValue: (snode nextCalls at: aRowNumber).
		
	^ index! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/28/2011 11:41:25.33'!
root

	^ root! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/28/2011 11:41:34.653'!
root: anSNode

	root := anSNode.! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 3/4/2011 11:51:19.778'!
rowCountFor: aParentModelIndex

	^ (aParentModelIndex
		ifNil: [self root rootNode ifNil: [^0]]
		ifNotNil: [:p | p valueOfProperty: #snode]) nextCalls size! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 3/23/2011 14:46:41.336'!
textFor: aModelIndex

	aModelIndex row = 0 ifTrue: [
		aModelIndex column = 1 ifTrue: [^ 'CallTree'].
		aModelIndex column = 2 ifTrue: [^ 'Time (ms)']].
	aModelIndex column = 0 ifTrue: [^ ''].
	
	aModelIndex column = 1 ifTrue: [
		^ (aModelIndex valueOfProperty: #snode) ifNotNil: [:snode |
			('{1}\\>\\><b>{2}</b>' format: {snode clientClass name. snode clientSelector}) asHtmlText]].
	
	aModelIndex column = 2 ifTrue: [
		^ (aModelIndex valueOfProperty: #snode) ifNotNil: [:snode |
			(snode profiles at: #ms ifAbsent: ['ms']) allButLast: 2]].! !

UiTextEdit subclass: #SdSourceCodeEdit
	instanceVariableNames: 'theClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSourceCodeEdit commentStamp: 'mt 3/24/2011 11:22:15.769' prior: 0!
This is a text edit to modify a method's source.!

!SdSourceCodeEdit methodsFor: 'initialization' stamp: 'mt 3/24/2011 11:14:20.341'!
initialize

	super initialize.
	
	self textMorph font: Preferences standardCodeFont.
	self textMorph styler: SHTextStylerST80 new.! !

!SdSourceCodeEdit methodsFor: 'initialization' stamp: 'mt 3/24/2011 11:37:47.45'!
reset

	(self theClass notNil and: [self theClass includesSelector: self selector])
		ifFalse: [^ self theText: ''].

	self textMorph styler classOrMetaClass: self theClass.  

	self theText: (self theClass >> self selector) getSource.
	
	self sourceCodeResetted.! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:01:21.227'!
selector

	^ selector! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:06:10.106'!
selector: aSymbol

	selector := aSymbol.
	self reset.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 3/24/2011 11:37:39.359'!
sourceCodeResetted

	self emit.! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:01:05.836'!
theClass

	^ theClass! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:06:15.094'!
theClass: aClassOrMetaClass

	theClass := aClassOrMetaClass.
	self reset.! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:06:49.905'!
theClass: aClassOrMetaClass selector: aSymbol

	theClass := aClassOrMetaClass.
	selector := aSymbol.
	
	self reset.! !

UiScrollArea subclass: #SdClassEditor
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdClassEditor commentStamp: 'mt 3/24/2011 13:38:22.775' prior: 0!
SdClassEditor new
	width: 500;
	theClass: SdCallgraphModel;
	reset;
	openInWorld.!

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 3/24/2011 13:29:43.665'!
initialize

	super initialize.
	
	self horizontalScrollBarPolicy: #alwaysOff.
	self verticalScrollBarPolicy: #alwaysOn.

	self verticalScrollBar singleStep: 20.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 3/24/2011 13:26:35.17'!
reset

	| container |
	self widget: nil.
	
	self theClass ifNil: [^ self].

	container := Morph new.
		
	self theClass selectors do: [:selector |
		container addMorphBack: (SdMethodEditor new
			theClass: self theClass
			selector: selector;
			hResizing: #spaceFill)].

	container
		changeTableLayout;
		color: Color transparent;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom.
		
	self widget: container.! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 3/24/2011 12:18:41.233'!
theClass

	^ theClass! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 3/24/2011 12:18:33.495'!
theClass: classOrMetaClass

	theClass := classOrMetaClass.! !

!SdClassEditor methodsFor: 'layouting' stamp: 'mt 3/24/2011 12:20:30.351'!
updateLayout

	super updateLayout.
	
	self widget ifNotNil: [:w |
		w width: self transformMorph width].! !

Morph subclass: #SdMethodEditor
	instanceVariableNames: 'sourceCodeEdit toggleBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdMethodEditor methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2011 16:12:11.428'!
initialize

	super initialize.
	sourceCodeEdit := SdSourceCodeEdit new
		hResizing: #spaceFill;
		vResizing: #rigid.
	sourceCodeEdit textMorph margins: (20@0 corner: 3@0).

	toggleBtn := UiPushButton new checkable: true.
		
	self
		color: Color transparent;
		changeTableLayout;
		listDirection: #topToBottom;
		vResizing: #shrinkWrap;  
		addMorphBack: toggleBtn;
		addMorphBack: sourceCodeEdit;
		updateLayout.
		
	self connect: toggleBtn signal: #toggled: toSelector: #updateLayout.
	self connect: sourceCodeEdit signal: #sourceCodeResetted toSelector: #updateLayout.! !

!SdMethodEditor methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2011 11:24:51.55'!
selector

	^ sourceCodeEdit selector! !

!SdMethodEditor methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2011 11:24:59.153'!
selector: aSymbol

	sourceCodeEdit selector: aSymbol.! !

!SdMethodEditor methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2011 11:55:41.708'!
selectorText

	| result |
	result := sourceCodeEdit selector asString asText.
	result addAttribute: (TextFontReference toFont: (sourceCodeEdit textMorph textStyle defaultFont))  .
	^ result
	! !

!SdMethodEditor methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2011 11:24:23.261'!
theClass

	^ sourceCodeEdit theClass! !

!SdMethodEditor methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2011 11:24:43.425'!
theClass: aClassOrMetaClass

	sourceCodeEdit theClass: aClassOrMetaClass.! !

!SdMethodEditor methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2011 11:38:38.405'!
theClass: aClassOrMetaClass selector: aSymbol

	sourceCodeEdit
		theClass: aClassOrMetaClass
		selector: aSymbol.! !

!SdMethodEditor methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2011 16:11:31.725'!
updateLayout

	"self removeMorph: sourceCodeEdit."
	
	toggleBtn checked
		ifTrue: [
			toggleBtn
				disableTableLayout: true;
				hResizing: #rigid;
				width: 16;  
				text: nil;
				icon: (UiFugueIcons toggleSmallIcon clippedTo: 9@16);
				topLeft: self topLeft.
			sourceCodeEdit
				disableTableLayout: false;
				show.
			sourceCodeEdit textMorph grabKeyboard]
		ifFalse: [
			toggleBtn
				disableTableLayout: false;
				hResizing: #spaceFill;
				text: self selectorText;
				icon: (UiFugueIcons toggleSmallExpandIcon clippedTo: 9@16).
			sourceCodeEdit
				disableTableLayout: true;
				hide].
		self layoutChanged.! !
